# Malfunctions and assertions

Internal malfunctions and assertions. More...

## Defines
#define | SVN_ERR_MALFUNCTION()
| Report that an internal malfunction has occurred, and possibly terminate the program.
#define | SVN_ERR_MALFUNCTION_NO_RETURN()
| Similar to SVN_ERR_MALFUNCTION(), but without the option of returning an error to the calling function.
#define | SVN_ERR_ASSERT(expr)
| Check that a condition is true: if not, report an error and possibly terminate the program.
#define | SVN_ERR_ASSERT_NO_RETURN(expr)
| Similar to SVN_ERR_ASSERT(), but without the option of returning an error to the calling function.
#define | SVN__NOT_IMPLEMENTED() return svn_error__malfunction(TRUE, __FILE__, __LINE__, "Not implemented.")
| Report a "Not implemented" malfunction.
## Typedefs
typedef svn_error_t *(* | svn_error_malfunction_handler_t )(svn_boolean_t can_return, const char *file, int line, const char *expr)
| A type of function that handles an assertion failure or other internal malfunction detected within the Subversion libraries.
## Functions
svn_error_t * | svn_error__malfunction (svn_boolean_t can_return, const char *file, int line, const char *expr)
| A helper function for the macros that report malfunctions.
svn_error_malfunction_handler_t | svn_error_set_malfunction_handler (svn_error_malfunction_handler_t func)
| Cause subsequent malfunctions to be handled by func.
svn_error_t * | svn_error_raise_on_malfunction (svn_boolean_t can_return, const char *file, int line, const char *expr)
| Handle a malfunction by returning an error object that describes it.
svn_error_t * | svn_error_abort_on_malfunction (svn_boolean_t can_return, const char *file, int line, const char *expr)
| Handle a malfunction by printing a message to stderr and aborting.

## Detailed Description

Internal malfunctions and assertions.

## Define Documentation

#define SVN__NOT_IMPLEMENTED | ( |  | ) | return svn_error__malfunction(TRUE, __FILE__, __LINE__, "Not implemented.")

Report a "Not implemented" malfunction.

Internal use only.

Definition at line 504 of file svn_error.h.

#define SVN_ERR_ASSERT | ( | expr |  | ) |

Value:

    do {                                                                  \
        if (!(expr))                                                        \
          SVN_ERR(svn_error__malfunction(TRUE, __FILE__, __LINE__, #expr)); \
      } while (0)

Check that a condition is true: if not, report an error and possibly terminate the program.

If the Boolean expression expr is true, do nothing. Otherwise, act as determined by the current "malfunction handler" which may have been specified by a call to svn_error_set_malfunction_handler() or else is the default handler as specified in that function's documentation. If the malfunction handler returns, then cause the function using this macro to return the error object that it generated.

Note:
  The intended use of this macro is to check a condition that cannot possibly be false unless there is a bug in the program.
  The condition to be checked should not be computationally expensive if it is reached often, as, unlike traditional "assert" statements, the evaluation of this expression is not compiled out in release-mode builds.

Since:
  New in 1.6.

Definition at line 482 of file svn_error.h.

#define SVN_ERR_ASSERT_NO_RETURN | ( | expr |  | ) |

Value:

    do {                                                          \
        if (!(expr)) {                                              \
          svn_error__malfunction(FALSE, __FILE__, __LINE__, #expr); \
          abort();                                                  \
        }                                                           \
      } while (0)

Similar to SVN_ERR_ASSERT(), but without the option of returning an error to the calling function.

If possible you should use SVN_ERR_ASSERT() instead.

Since:
  New in 1.6.

Definition at line 495 of file svn_error.h.

#define SVN_ERR_MALFUNCTION | ( |  | ) |

Value:

    do {                                                             \
        return svn_error_trace(svn_error__malfunction(                 \
                                     TRUE, __FILE__, __LINE__, NULL)); \
      } while (0)

Report that an internal malfunction has occurred, and possibly terminate the program.

Act as determined by the current "malfunction handler" which may have been specified by a call to svn_error_set_malfunction_handler() or else is the default handler as specified in that function's documentation. If the malfunction handler returns, then cause the function using this macro to return the error object that it generated.

Note:
  The intended use of this macro is where execution reaches a point that cannot possibly be reached unless there is a bug in the program.

Since:
  New in 1.6.

Definition at line 444 of file svn_error.h.

#define SVN_ERR_MALFUNCTION_NO_RETURN | ( |  | ) |

Value:

    do {                                                       \
        svn_error__malfunction(FALSE, __FILE__, __LINE__, NULL); \
        abort();                                                 \
      } while (1)

Similar to SVN_ERR_MALFUNCTION(), but without the option of returning an error to the calling function.

If possible you should use SVN_ERR_MALFUNCTION() instead.

Since:
  New in 1.6.

Definition at line 457 of file svn_error.h.

## Typedef Documentation

typedef svn_error_t*(* svn_error_malfunction_handler_t)(svn_boolean_t can_return, const char *file, int line, const char *expr)

A type of function that handles an assertion failure or other internal malfunction detected within the Subversion libraries.

The error occurred in the source file file at line line, and was an assertion failure of the expression expr, or, if expr is null, an unconditional error.

If can_return is false a function of this type must never return.

If can_return is true a function of this type must do one of:

- Return an error object describing the error, using an error code in the category SVN_ERR_MALFUNC_CATEGORY_START.
- Never return.

The function may alter its behaviour according to compile-time and run-time and even interactive conditions.

See also:
  SVN_ERROR_IN_CATEGORY()

Since:
  New in 1.6.

Definition at line 550 of file svn_error.h.

## Function Documentation

svn_error_t* svn_error__malfunction | ( | svn_boolean_t | can_return,
|  | const char * | file,
|  | int | line,
|  | const char * | expr |
| ) |  |  |

A helper function for the macros that report malfunctions.

Handle a malfunction by calling the current "malfunction handler" which may have been specified by a call to svn_error_set_malfunction_handler() or else is the default handler as specified in that function's documentation.

Pass all of the parameters to the handler. The error occurred in the source file file at line line, and was an assertion failure of the expression expr, or, if expr is null, an unconditional error.

If can_return is true, the handler can return an error object that is returned by the caller. If can_return is false the method should never return. (The caller will call abort())

Since:
  New in 1.6.

svn_error_t* svn_error_abort_on_malfunction | ( | svn_boolean_t | can_return,
|  | const char * | file,
|  | int | line,
|  | const char * | expr |
| ) |  |  |

Handle a malfunction by printing a message to stderr and aborting.

This function implements `svn_error_malfunction_handler_t`.

Since:
  New in 1.6.

svn_error_t* svn_error_raise_on_malfunction | ( | svn_boolean_t | can_return,
|  | const char * | file,
|  | int | line,
|  | const char * | expr |
| ) |  |  |

Handle a malfunction by returning an error object that describes it.

When can_return is false, abort()

This function implements `svn_error_malfunction_handler_t`.

Since:
  New in 1.6.

svn_error_malfunction_handler_t svn_error_set_malfunction_handler | ( | svn_error_malfunction_handler_t | func | ) |

Cause subsequent malfunctions to be handled by func.

Return the handler that was previously in effect.

func may not be null.

Note:
  The default handler is svn_error_abort_on_malfunction().
  This function must be called in a single-threaded context.

Since:
  New in 1.6.

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Defines